gtkmm: Gtk::TreeSortable Class Reference

# Gtk::TreeSortable Class Reference
[TreeView Classes]

Inherits Glib::Interface.

Inherited by Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

Collaboration diagram for Gtk::TreeSortable:
[legend]

List of all members.

## Public Types

enum | { DEFAULT_SORT_COLUMN_ID = -1, DEFAULT_UNSORTED_COLUMN_ID = -2 }
typedef sigc::slot< int, const Gtk::TreeModel::iterator &, const Gtk::TreeModel::iterator& > | SlotCompare
| This callback should return -1 if a compares before b, 0 if they compare equal, 1 if a compares after b.

## Public Member Functions

virtual | ~TreeSortable ()
GtkTreeSortable* | gobj ()
| Provides access to the underlying C GObject.
const GtkTreeSortable* | gobj () const
| Provides access to the underlying C GObject.
bool | get_sort_column_id (int& sort_column_id, SortType& order) const
| Fills in sort_column_id and order with the current sort column and the order.
void | set_sort_column (const TreeModelColumnBase& sort_column_id, SortType order)
| Sets the current sort column to be sort_column_id.
void | set_sort_column (int sort_column_id, SortType order)
| Sets the current sort column to be sort_column_id.
void | set_sort_column_id (const TreeModelColumnBase& sort_column_id, SortType order)
void | set_sort_column_id (int sort_column_id, SortType order)
void | set_sort_func (const TreeModelColumnBase& sort_column, const SlotCompare& slot)
| Sets the comparison function used when sorting a certain column.
void | set_sort_func (int sort_column_id, const SlotCompare& slot)
| Sets the comparison function used when sorting a certain column.
void | set_default_sort_func (const SlotCompare& slot)
| Sets the default comparison function used when sorting.
void | unset_default_sort_func ()
| Sets the default comparison function used when sorting.
bool | has_default_sort_func () const
| Returns `true` if the model has a default sort function.
void | sort_column_changed ()
| Emits a Gtk::TreeSortable::sort-column-changed signal on sortable.
Glib::SignalProxy0< void > | signal_sort_column_changed ()

## Static Public Member Functions

static void | add_interface (GType gtype_implementer)

## Protected Member Functions

virtual bool | get_sort_column_id_vfunc (int* sort_column_id, SortType* order) const
virtual void | set_sort_column_id_vfunc (int sort_column_id, SortType order)
virtual void | set_sort_func_vfunc (int sort_column_id, GtkTreeIterCompareFunc func, void* data, GDestroyNotify destroy)
virtual void | set_default_sort_func_vfunc (GtkTreeIterCompareFunc func, void* data, GDestroyNotify destroy)
virtual bool | has_default_sort_func_vfunc () const
virtual void | sort_column_changed_vfunc () const
virtual void | on_sort_column_changed ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gtk::TreeSortable > | wrap (GtkTreeSortable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Member Typedef Documentation

typedef sigc::slot<int, const Gtk::TreeModel::iterator&, const Gtk::TreeModel::iterator&> Gtk::TreeSortable::SlotCompare

This callback should return -1 if a compares before b, 0 if they compare equal, 1 if a compares after b.

For instance, int on_sort_compare(const Gtk::TreeModel::iterator& a, const Gtk::TreeModel::iterator& b);

## Member Enumeration Documentation

anonymous enum

Enumerator:

  DEFAULT_SORT_COLUMN_ID | See set_default_sort_func() and set_sort_column().
  DEFAULT_UNSORTED_COLUMN_ID |

## Constructor & Destructor Documentation

virtual Gtk::TreeSortable::~TreeSortable | ( |  | ) | `[virtual]`

## Member Function Documentation

static void Gtk::TreeSortable::add_interface | ( | GType | gtype_implementer | ) | `[static]`

bool Gtk::TreeSortable::get_sort_column_id | ( | int & | sort_column_id,
|  | SortType& | order |
| ) |  |  | const

Fills in sort_column_id and order with the current sort column and the order.

It returns `true` unless the sort_column_id is Gtk::TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID or Gtk::TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID.

Parameters:

  | sort_column_id | The sort column id to be filled in.
  | order | The Gtk::SortType to be filled in.

Returns:
  `true` if the sort column is not one of the special sort column ids.

virtual bool Gtk::TreeSortable::get_sort_column_id_vfunc | ( | int * | sort_column_id,
|  | SortType* | order |
| ) |  |  | const`[protected, virtual]`

const GtkTreeSortable* Gtk::TreeSortable::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

GtkTreeSortable* Gtk::TreeSortable::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

bool Gtk::TreeSortable::has_default_sort_func | ( |  | ) | const

Returns `true` if the model has a default sort function.

This is used primarily by GtkTreeViewColumns in order to determine if a model can go back to the default state, or not.

Returns:
  `true`, if the model has a default sort function.

virtual bool Gtk::TreeSortable::has_default_sort_func_vfunc | ( |  | ) | const`[protected, virtual]`

virtual void Gtk::TreeSortable::on_sort_column_changed | ( |  | ) | `[protected, virtual]`

void Gtk::TreeSortable::set_default_sort_func | ( | const SlotCompare & | slot | ) |

Sets the default comparison function used when sorting.

If the current sort column id of sortable is DEFAULT_SORT_COLUMN_ID, then the model will sort using this function. See also unset_default_sort_func().

Parameters:

  | slot | The sorting function

virtual void Gtk::TreeSortable::set_default_sort_func_vfunc | ( | GtkTreeIterCompareFunc | func,
|  | void * | data,
|  | GDestroyNotify | destroy |
| ) |  |  | `[protected, virtual]`

void Gtk::TreeSortable::set_sort_column | ( | int | sort_column_id,
|  | SortType | order |
| ) |  |  |

Sets the current sort column to be sort_column_id.

The sortable will resort itself to reflect this change, after emitting a Gtk::TreeSortable::sort-column-changed signal. sortable may either be a regular column id, or one of the following special values: <variablelist> <varlistentry> Gtk::TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID <listitem>the default sort function will be used, if it is set</listitem> </varlistentry> <varlistentry> Gtk::TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID <listitem>no sorting will occur</listitem> </varlistentry> </variablelist>

Parameters:

  | sort_column_id | The sort column id to set.
  | order | The sort order of the column.

void Gtk::TreeSortable::set_sort_column | ( | const TreeModelColumnBase& | sort_column_id,
|  | SortType | order |
| ) |  |  |

Sets the current sort column to be sort_column_id.

The sortable will resort itself to reflect this change, after emitting a Gtk::TreeSortable::sort-column-changed signal. sortable may either be a regular column id, or one of the following special values: <variablelist> <varlistentry> Gtk::TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID <listitem>the default sort function will be used, if it is set</listitem> </varlistentry> <varlistentry> Gtk::TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID <listitem>no sorting will occur</listitem> </varlistentry> </variablelist>

Parameters:

  | sort_column_id | The sort column id to set.
  | order | The sort order of the column.

void Gtk::TreeSortable::set_sort_column_id | ( | int | sort_column_id,
|  | SortType | order |
| ) |  |  |

Deprecated:
  Use set_sort_column() instead.

void Gtk::TreeSortable::set_sort_column_id | ( | const TreeModelColumnBase& | sort_column_id,
|  | SortType | order |
| ) |  |  |

Deprecated:
  Use set_sort_column() instead.

virtual void Gtk::TreeSortable::set_sort_column_id_vfunc | ( | int | sort_column_id,
|  | SortType | order |
| ) |  |  | `[protected, virtual]`

void Gtk::TreeSortable::set_sort_func | ( | int | sort_column_id,
|  | const SlotCompare & | slot |
| ) |  |  |

Sets the comparison function used when sorting a certain column.

If the current sort column id is the same as sort_column_id, then the model will sort using this function.

Parameters:

  | sort_column_id | the sort column id to set the function for
  | slot | The sorting slot callback.

void Gtk::TreeSortable::set_sort_func | ( | const TreeModelColumnBase& | sort_column,
|  | const SlotCompare & | slot |
| ) |  |  |

Sets the comparison function used when sorting a certain column.

If the current sort column is the same as sort_column, then the model will sort using this function.

Parameters:

  | sort_column | the sort column to set the function for
  | slot | The sorting slot callback.

virtual void Gtk::TreeSortable::set_sort_func_vfunc | ( | int | sort_column_id,
|  | GtkTreeIterCompareFunc | func,
|  | void * | data,
|  | GDestroyNotify | destroy |
| ) |  |  | `[protected, virtual]`

Glib::SignalProxy0< void > Gtk::TreeSortable::signal_sort_column_changed | ( |  | ) |

Prototype:
  `void on_my_sort_column_changed()`

void Gtk::TreeSortable::sort_column_changed | ( |  | ) |

Emits a Gtk::TreeSortable::sort-column-changed signal on sortable.

virtual void Gtk::TreeSortable::sort_column_changed_vfunc | ( |  | ) | const`[protected, virtual]`

void Gtk::TreeSortable::unset_default_sort_func | ( |  | ) |

Sets the default comparison function used when sorting.

See set_default_sort_func().

After calling this method there will be no default comparison function. This means that once the model has been sorted, it can't go back to the default state. In this case, when the current sort column id of sortable is DEFAULT_SORT_COLUMN_ID, the model will be unsorted.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::TreeSortable > wrap | ( | GtkTreeSortable * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/treesortable.h